package technobot.commands.fun;

import net.dv8tion.jda.api.events.interaction.command.SlashCommandInteractionEvent;
import technobot.TechnoBot;
import technobot.commands.Category;
import technobot.commands.Command;
import technobot.util.embeds.EmbedUtils;

import java.io.*;
import java.net.URL;
import java.net.URLConnection;

/**
 * Command that generates a funny inspiring quote.
 * Uses the InspiroBot API.
 *
 * @author TechnoVision
 */
public class InspireCommand extends Command {

    public InspireCommand(TechnoBot bot) {
        super(bot);
        this.name = "inspire";
        this.description = "Display an inspirational quote generated by an AI.";
        this.category = Category.FUN;
    }

    @Override
    public void execute(SlashCommandInteractionEvent event) {
        try {
            URLConnection connection = new URL("https://inspirobot.me/api?generate=true").openConnection();
            InputStream input = connection.getInputStream();
            String pictureUrl = new BufferedReader(new InputStreamReader(input)).readLine();
            event.reply(pictureUrl).queue();
        } catch (IOException e) {
            String text = "I was unable to fetch an inspiring quote!";
            event.replyEmbeds(EmbedUtils.createError(text)).queue();
        }
    }
}
